import { Http,Util } from '@/utils';
import EntityService from '../entity-service';



/**
 * 订单条目服务对象基类
 *
 * @export
 * @class EMPODetailServiceBase
 * @extends {EntityServie}
 */
export default class EMPODetailServiceBase extends EntityService {

    /**
     * Creates an instance of  EMPODetailServiceBase.
     * 
     * @param {*} [opts={}]
     * @memberof  EMPODetailServiceBase
     */
    constructor(opts: any = {}) {
        super(opts);
    }

    /**
     * 初始化基础数据
     *
     * @memberof EMPODetailServiceBase
     */
    public initBasicData(){
        this.APPLYDEKEY ='empodetail';
        this.APPDEKEY = 'empodetailid';
        this.APPDENAME = 'empodetails';
        this.APPDETEXT = 'empodetailname';
        this.APPNAME = 'eamweb';
        this.SYSTEMNAME = 'eam_practice03';
    }

// 实体接口

    /**
     * Select接口方法
     *
     * @param {*} [context={}]
     * @param {*} [data={}]
     * @param {boolean} [isloading]
     * @returns {Promise<any>}
     * @memberof EMPODetailServiceBase
     */
    public async Select(context: any = {},data: any = {}, isloading?: boolean): Promise<any> {
        if(context.emstore && context.emstorepart && context.emitem && context.empodetail){
            return Http.getInstance().get(`/emstores/${context.emstore}/emstoreparts/${context.emstorepart}/emitems/${context.emitem}/empodetails/${context.empodetail}/select`,isloading);
        }
        if(context.pfunit && context.emitem && context.empodetail){
            return Http.getInstance().get(`/pfunits/${context.pfunit}/emitems/${context.emitem}/empodetails/${context.empodetail}/select`,isloading);
        }
        if(context.pfemp && context.emitem && context.empodetail){
            return Http.getInstance().get(`/pfemps/${context.pfemp}/emitems/${context.emitem}/empodetails/${context.empodetail}/select`,isloading);
        }
        if(context.emstore && context.emitem && context.empodetail){
            return Http.getInstance().get(`/emstores/${context.emstore}/emitems/${context.emitem}/empodetails/${context.empodetail}/select`,isloading);
        }
        if(context.emstorepart && context.emitem && context.empodetail){
            return Http.getInstance().get(`/emstoreparts/${context.emstorepart}/emitems/${context.emitem}/empodetails/${context.empodetail}/select`,isloading);
        }
        if(context.emservice && context.emitem && context.empodetail){
            return Http.getInstance().get(`/emservices/${context.emservice}/emitems/${context.emitem}/empodetails/${context.empodetail}/select`,isloading);
        }
        if(context.empo && context.empodetail){
            return Http.getInstance().get(`/empos/${context.empo}/empodetails/${context.empodetail}/select`,isloading);
        }
        if(context.emitem && context.empodetail){
            return Http.getInstance().get(`/emitems/${context.emitem}/empodetails/${context.empodetail}/select`,isloading);
        }
            return Http.getInstance().get(`/empodetails/${context.empodetail}/select`,isloading);
    }

    /**
     * Update接口方法
     *
     * @param {*} [context={}]
     * @param {*} [data={}]
     * @param {boolean} [isloading]
     * @returns {Promise<any>}
     * @memberof EMPODetailServiceBase
     */
    public async Update(context: any = {},data: any = {}, isloading?: boolean): Promise<any> {
        if(context.emstore && context.emstorepart && context.emitem && context.empodetail){
            return Http.getInstance().put(`/emstores/${context.emstore}/emstoreparts/${context.emstorepart}/emitems/${context.emitem}/empodetails/${context.empodetail}`,data,isloading);
        }
        if(context.pfunit && context.emitem && context.empodetail){
            return Http.getInstance().put(`/pfunits/${context.pfunit}/emitems/${context.emitem}/empodetails/${context.empodetail}`,data,isloading);
        }
        if(context.pfemp && context.emitem && context.empodetail){
            return Http.getInstance().put(`/pfemps/${context.pfemp}/emitems/${context.emitem}/empodetails/${context.empodetail}`,data,isloading);
        }
        if(context.emstore && context.emitem && context.empodetail){
            return Http.getInstance().put(`/emstores/${context.emstore}/emitems/${context.emitem}/empodetails/${context.empodetail}`,data,isloading);
        }
        if(context.emstorepart && context.emitem && context.empodetail){
            return Http.getInstance().put(`/emstoreparts/${context.emstorepart}/emitems/${context.emitem}/empodetails/${context.empodetail}`,data,isloading);
        }
        if(context.emservice && context.emitem && context.empodetail){
            return Http.getInstance().put(`/emservices/${context.emservice}/emitems/${context.emitem}/empodetails/${context.empodetail}`,data,isloading);
        }
        if(context.empo && context.empodetail){
            return Http.getInstance().put(`/empos/${context.empo}/empodetails/${context.empodetail}`,data,isloading);
        }
        if(context.emitem && context.empodetail){
            return Http.getInstance().put(`/emitems/${context.emitem}/empodetails/${context.empodetail}`,data,isloading);
        }
        let masterData:any = {};
        Object.assign(data,masterData);
            let res:any = await  Http.getInstance().put(`/empodetails/${context.empodetail}`,data,isloading);
            return res;
    }

    /**
     * Get接口方法
     *
     * @param {*} [context={}]
     * @param {*} [data={}]
     * @param {boolean} [isloading]
     * @returns {Promise<any>}
     * @memberof EMPODetailServiceBase
     */
    public async Get(context: any = {},data: any = {}, isloading?: boolean): Promise<any> {
        if(context.emstore && context.emstorepart && context.emitem && context.empodetail){
            return Http.getInstance().get(`/emstores/${context.emstore}/emstoreparts/${context.emstorepart}/emitems/${context.emitem}/empodetails/${context.empodetail}`,isloading);
        }
        if(context.pfunit && context.emitem && context.empodetail){
            return Http.getInstance().get(`/pfunits/${context.pfunit}/emitems/${context.emitem}/empodetails/${context.empodetail}`,isloading);
        }
        if(context.pfemp && context.emitem && context.empodetail){
            return Http.getInstance().get(`/pfemps/${context.pfemp}/emitems/${context.emitem}/empodetails/${context.empodetail}`,isloading);
        }
        if(context.emstore && context.emitem && context.empodetail){
            return Http.getInstance().get(`/emstores/${context.emstore}/emitems/${context.emitem}/empodetails/${context.empodetail}`,isloading);
        }
        if(context.emstorepart && context.emitem && context.empodetail){
            return Http.getInstance().get(`/emstoreparts/${context.emstorepart}/emitems/${context.emitem}/empodetails/${context.empodetail}`,isloading);
        }
        if(context.emservice && context.emitem && context.empodetail){
            return Http.getInstance().get(`/emservices/${context.emservice}/emitems/${context.emitem}/empodetails/${context.empodetail}`,isloading);
        }
        if(context.empo && context.empodetail){
            return Http.getInstance().get(`/empos/${context.empo}/empodetails/${context.empodetail}`,isloading);
        }
        if(context.emitem && context.empodetail){
            return Http.getInstance().get(`/emitems/${context.emitem}/empodetails/${context.empodetail}`,isloading);
        }
            let res:any = await Http.getInstance().get(`/empodetails/${context.empodetail}`,isloading);
            return res;

    }

    /**
     * Create接口方法
     *
     * @param {*} [context={}]
     * @param {*} [data={}]
     * @param {boolean} [isloading]
     * @returns {Promise<any>}
     * @memberof EMPODetailServiceBase
     */
    public async Create(context: any = {},data: any = {}, isloading?: boolean): Promise<any> {
        if(context.emstore && context.emstorepart && context.emitem && true){
            if(!data.srffrontuf || data.srffrontuf !== "1"){
                data[this.APPDEKEY] = null;
            }
            if(data.srffrontuf){
                delete data.srffrontuf;
            }
            return Http.getInstance().post(`/emstores/${context.emstore}/emstoreparts/${context.emstorepart}/emitems/${context.emitem}/empodetails`,data,isloading);
        }
        if(context.pfunit && context.emitem && true){
            if(!data.srffrontuf || data.srffrontuf !== "1"){
                data[this.APPDEKEY] = null;
            }
            if(data.srffrontuf){
                delete data.srffrontuf;
            }
            return Http.getInstance().post(`/pfunits/${context.pfunit}/emitems/${context.emitem}/empodetails`,data,isloading);
        }
        if(context.pfemp && context.emitem && true){
            if(!data.srffrontuf || data.srffrontuf !== "1"){
                data[this.APPDEKEY] = null;
            }
            if(data.srffrontuf){
                delete data.srffrontuf;
            }
            return Http.getInstance().post(`/pfemps/${context.pfemp}/emitems/${context.emitem}/empodetails`,data,isloading);
        }
        if(context.emstore && context.emitem && true){
            if(!data.srffrontuf || data.srffrontuf !== "1"){
                data[this.APPDEKEY] = null;
            }
            if(data.srffrontuf){
                delete data.srffrontuf;
            }
            return Http.getInstance().post(`/emstores/${context.emstore}/emitems/${context.emitem}/empodetails`,data,isloading);
        }
        if(context.emstorepart && context.emitem && true){
            if(!data.srffrontuf || data.srffrontuf !== "1"){
                data[this.APPDEKEY] = null;
            }
            if(data.srffrontuf){
                delete data.srffrontuf;
            }
            return Http.getInstance().post(`/emstoreparts/${context.emstorepart}/emitems/${context.emitem}/empodetails`,data,isloading);
        }
        if(context.emservice && context.emitem && true){
            if(!data.srffrontuf || data.srffrontuf !== "1"){
                data[this.APPDEKEY] = null;
            }
            if(data.srffrontuf){
                delete data.srffrontuf;
            }
            return Http.getInstance().post(`/emservices/${context.emservice}/emitems/${context.emitem}/empodetails`,data,isloading);
        }
        if(context.empo && true){
            if(!data.srffrontuf || data.srffrontuf !== "1"){
                data[this.APPDEKEY] = null;
            }
            if(data.srffrontuf){
                delete data.srffrontuf;
            }
            return Http.getInstance().post(`/empos/${context.empo}/empodetails`,data,isloading);
        }
        if(context.emitem && true){
            if(!data.srffrontuf || data.srffrontuf !== "1"){
                data[this.APPDEKEY] = null;
            }
            if(data.srffrontuf){
                delete data.srffrontuf;
            }
            return Http.getInstance().post(`/emitems/${context.emitem}/empodetails`,data,isloading);
        }
        let masterData:any = {};
        Object.assign(data,masterData);
        if(!data.srffrontuf || data.srffrontuf !== "1"){
            data[this.APPDEKEY] = null;
        }
        if(data.srffrontuf){
            delete data.srffrontuf;
        }
        let tempContext:any = JSON.parse(JSON.stringify(context));
        let res:any = await Http.getInstance().post(`/empodetails`,data,isloading);
        return res;
    }

    /**
     * GetDraft接口方法
     *
     * @param {*} [context={}]
     * @param {*} [data={}]
     * @param {boolean} [isloading]
     * @returns {Promise<any>}
     * @memberof EMPODetailServiceBase
     */
    public async GetDraft(context: any = {},data: any = {}, isloading?: boolean): Promise<any> {
        if(context.emstore && context.emstorepart && context.emitem && true){
            return Http.getInstance().get(`/emstores/${context.emstore}/emstoreparts/${context.emstorepart}/emitems/${context.emitem}/empodetails/getdraft`,isloading);
        }
        if(context.pfunit && context.emitem && true){
            return Http.getInstance().get(`/pfunits/${context.pfunit}/emitems/${context.emitem}/empodetails/getdraft`,isloading);
        }
        if(context.pfemp && context.emitem && true){
            return Http.getInstance().get(`/pfemps/${context.pfemp}/emitems/${context.emitem}/empodetails/getdraft`,isloading);
        }
        if(context.emstore && context.emitem && true){
            return Http.getInstance().get(`/emstores/${context.emstore}/emitems/${context.emitem}/empodetails/getdraft`,isloading);
        }
        if(context.emstorepart && context.emitem && true){
            return Http.getInstance().get(`/emstoreparts/${context.emstorepart}/emitems/${context.emitem}/empodetails/getdraft`,isloading);
        }
        if(context.emservice && context.emitem && true){
            return Http.getInstance().get(`/emservices/${context.emservice}/emitems/${context.emitem}/empodetails/getdraft`,isloading);
        }
        if(context.empo && true){
            return Http.getInstance().get(`/empos/${context.empo}/empodetails/getdraft`,isloading);
        }
        if(context.emitem && true){
            return Http.getInstance().get(`/emitems/${context.emitem}/empodetails/getdraft`,isloading);
        }
        let res:any = await  Http.getInstance().get(`/empodetails/getdraft`,isloading);
        res.data.empodetail = data.empodetail;
        return res;
    }

    /**
     * Save接口方法
     *
     * @param {*} [context={}]
     * @param {*} [data={}]
     * @param {boolean} [isloading]
     * @returns {Promise<any>}
     * @memberof EMPODetailServiceBase
     */
    public async Save(context: any = {},data: any = {}, isloading?: boolean): Promise<any> {
        if(context.emstore && context.emstorepart && context.emitem && context.empodetail){
            return Http.getInstance().post(`/emstores/${context.emstore}/emstoreparts/${context.emstorepart}/emitems/${context.emitem}/empodetails/${context.empodetail}/save`,data,isloading);
        }
        if(context.pfunit && context.emitem && context.empodetail){
            return Http.getInstance().post(`/pfunits/${context.pfunit}/emitems/${context.emitem}/empodetails/${context.empodetail}/save`,data,isloading);
        }
        if(context.pfemp && context.emitem && context.empodetail){
            return Http.getInstance().post(`/pfemps/${context.pfemp}/emitems/${context.emitem}/empodetails/${context.empodetail}/save`,data,isloading);
        }
        if(context.emstore && context.emitem && context.empodetail){
            return Http.getInstance().post(`/emstores/${context.emstore}/emitems/${context.emitem}/empodetails/${context.empodetail}/save`,data,isloading);
        }
        if(context.emstorepart && context.emitem && context.empodetail){
            return Http.getInstance().post(`/emstoreparts/${context.emstorepart}/emitems/${context.emitem}/empodetails/${context.empodetail}/save`,data,isloading);
        }
        if(context.emservice && context.emitem && context.empodetail){
            return Http.getInstance().post(`/emservices/${context.emservice}/emitems/${context.emitem}/empodetails/${context.empodetail}/save`,data,isloading);
        }
        if(context.empo && context.empodetail){
            return Http.getInstance().post(`/empos/${context.empo}/empodetails/${context.empodetail}/save`,data,isloading);
        }
        if(context.emitem && context.empodetail){
            return Http.getInstance().post(`/emitems/${context.emitem}/empodetails/${context.empodetail}/save`,data,isloading);
        }
        let masterData:any = {};
        Object.assign(data,masterData);
            let res:any = await  Http.getInstance().post(`/empodetails/${context.empodetail}/save`,data,isloading);
            return res;
    }

    /**
     * CheckKey接口方法
     *
     * @param {*} [context={}]
     * @param {*} [data={}]
     * @param {boolean} [isloading]
     * @returns {Promise<any>}
     * @memberof EMPODetailServiceBase
     */
    public async CheckKey(context: any = {},data: any = {}, isloading?: boolean): Promise<any> {
        if(context.emstore && context.emstorepart && context.emitem && context.empodetail){
            return Http.getInstance().post(`/emstores/${context.emstore}/emstoreparts/${context.emstorepart}/emitems/${context.emitem}/empodetails/${context.empodetail}/checkkey`,data,isloading);
        }
        if(context.pfunit && context.emitem && context.empodetail){
            return Http.getInstance().post(`/pfunits/${context.pfunit}/emitems/${context.emitem}/empodetails/${context.empodetail}/checkkey`,data,isloading);
        }
        if(context.pfemp && context.emitem && context.empodetail){
            return Http.getInstance().post(`/pfemps/${context.pfemp}/emitems/${context.emitem}/empodetails/${context.empodetail}/checkkey`,data,isloading);
        }
        if(context.emstore && context.emitem && context.empodetail){
            return Http.getInstance().post(`/emstores/${context.emstore}/emitems/${context.emitem}/empodetails/${context.empodetail}/checkkey`,data,isloading);
        }
        if(context.emstorepart && context.emitem && context.empodetail){
            return Http.getInstance().post(`/emstoreparts/${context.emstorepart}/emitems/${context.emitem}/empodetails/${context.empodetail}/checkkey`,data,isloading);
        }
        if(context.emservice && context.emitem && context.empodetail){
            return Http.getInstance().post(`/emservices/${context.emservice}/emitems/${context.emitem}/empodetails/${context.empodetail}/checkkey`,data,isloading);
        }
        if(context.empo && context.empodetail){
            return Http.getInstance().post(`/empos/${context.empo}/empodetails/${context.empodetail}/checkkey`,data,isloading);
        }
        if(context.emitem && context.empodetail){
            return Http.getInstance().post(`/emitems/${context.emitem}/empodetails/${context.empodetail}/checkkey`,data,isloading);
        }
            return Http.getInstance().post(`/empodetails/${context.empodetail}/checkkey`,data,isloading);
    }

    /**
     * Remove接口方法
     *
     * @param {*} [context={}]
     * @param {*} [data={}]
     * @param {boolean} [isloading]
     * @returns {Promise<any>}
     * @memberof EMPODetailServiceBase
     */
    public async Remove(context: any = {},data: any = {}, isloading?: boolean): Promise<any> {
        if(context.emstore && context.emstorepart && context.emitem && context.empodetail){
            return Http.getInstance().delete(`/emstores/${context.emstore}/emstoreparts/${context.emstorepart}/emitems/${context.emitem}/empodetails/${context.empodetail}`,isloading);
        }
        if(context.pfunit && context.emitem && context.empodetail){
            return Http.getInstance().delete(`/pfunits/${context.pfunit}/emitems/${context.emitem}/empodetails/${context.empodetail}`,isloading);
        }
        if(context.pfemp && context.emitem && context.empodetail){
            return Http.getInstance().delete(`/pfemps/${context.pfemp}/emitems/${context.emitem}/empodetails/${context.empodetail}`,isloading);
        }
        if(context.emstore && context.emitem && context.empodetail){
            return Http.getInstance().delete(`/emstores/${context.emstore}/emitems/${context.emitem}/empodetails/${context.empodetail}`,isloading);
        }
        if(context.emstorepart && context.emitem && context.empodetail){
            return Http.getInstance().delete(`/emstoreparts/${context.emstorepart}/emitems/${context.emitem}/empodetails/${context.empodetail}`,isloading);
        }
        if(context.emservice && context.emitem && context.empodetail){
            return Http.getInstance().delete(`/emservices/${context.emservice}/emitems/${context.emitem}/empodetails/${context.empodetail}`,isloading);
        }
        if(context.empo && context.empodetail){
            return Http.getInstance().delete(`/empos/${context.empo}/empodetails/${context.empodetail}`,isloading);
        }
        if(context.emitem && context.empodetail){
            return Http.getInstance().delete(`/emitems/${context.emitem}/empodetails/${context.empodetail}`,isloading);
        }
            return Http.getInstance().delete(`/empodetails/${context.empodetail}`,isloading);

    }

    /**
     * FetchLaterYear接口方法
     *
     * @param {*} [context={}]
     * @param {*} [data={}]
     * @param {boolean} [isloading]
     * @returns {Promise<any>}
     * @memberof EMPODetailServiceBase
     */
    public async FetchLaterYear(context: any = {},data: any = {}, isloading?: boolean): Promise<any> {
        if(context.emstore && context.emstorepart && context.emitem && true){
            let tempData:any = JSON.parse(JSON.stringify(data));
            return Http.getInstance().get(`/emstores/${context.emstore}/emstoreparts/${context.emstorepart}/emitems/${context.emitem}/empodetails/fetchlateryear`,tempData,isloading);
        }
        if(context.pfunit && context.emitem && true){
            let tempData:any = JSON.parse(JSON.stringify(data));
            return Http.getInstance().get(`/pfunits/${context.pfunit}/emitems/${context.emitem}/empodetails/fetchlateryear`,tempData,isloading);
        }
        if(context.pfemp && context.emitem && true){
            let tempData:any = JSON.parse(JSON.stringify(data));
            return Http.getInstance().get(`/pfemps/${context.pfemp}/emitems/${context.emitem}/empodetails/fetchlateryear`,tempData,isloading);
        }
        if(context.emstore && context.emitem && true){
            let tempData:any = JSON.parse(JSON.stringify(data));
            return Http.getInstance().get(`/emstores/${context.emstore}/emitems/${context.emitem}/empodetails/fetchlateryear`,tempData,isloading);
        }
        if(context.emstorepart && context.emitem && true){
            let tempData:any = JSON.parse(JSON.stringify(data));
            return Http.getInstance().get(`/emstoreparts/${context.emstorepart}/emitems/${context.emitem}/empodetails/fetchlateryear`,tempData,isloading);
        }
        if(context.emservice && context.emitem && true){
            let tempData:any = JSON.parse(JSON.stringify(data));
            return Http.getInstance().get(`/emservices/${context.emservice}/emitems/${context.emitem}/empodetails/fetchlateryear`,tempData,isloading);
        }
        if(context.empo && true){
            let tempData:any = JSON.parse(JSON.stringify(data));
            return Http.getInstance().get(`/empos/${context.empo}/empodetails/fetchlateryear`,tempData,isloading);
        }
        if(context.emitem && true){
            let tempData:any = JSON.parse(JSON.stringify(data));
            return Http.getInstance().get(`/emitems/${context.emitem}/empodetails/fetchlateryear`,tempData,isloading);
        }
        let tempData:any = JSON.parse(JSON.stringify(data));
        return Http.getInstance().get(`/empodetails/fetchlateryear`,tempData,isloading);
    }

    /**
     * FetchDefault接口方法
     *
     * @param {*} [context={}]
     * @param {*} [data={}]
     * @param {boolean} [isloading]
     * @returns {Promise<any>}
     * @memberof EMPODetailServiceBase
     */
    public async FetchDefault(context: any = {},data: any = {}, isloading?: boolean): Promise<any> {
        if(context.emstore && context.emstorepart && context.emitem && true){
            let tempData:any = JSON.parse(JSON.stringify(data));
            return Http.getInstance().get(`/emstores/${context.emstore}/emstoreparts/${context.emstorepart}/emitems/${context.emitem}/empodetails/fetchdefault`,tempData,isloading);
        }
        if(context.pfunit && context.emitem && true){
            let tempData:any = JSON.parse(JSON.stringify(data));
            return Http.getInstance().get(`/pfunits/${context.pfunit}/emitems/${context.emitem}/empodetails/fetchdefault`,tempData,isloading);
        }
        if(context.pfemp && context.emitem && true){
            let tempData:any = JSON.parse(JSON.stringify(data));
            return Http.getInstance().get(`/pfemps/${context.pfemp}/emitems/${context.emitem}/empodetails/fetchdefault`,tempData,isloading);
        }
        if(context.emstore && context.emitem && true){
            let tempData:any = JSON.parse(JSON.stringify(data));
            return Http.getInstance().get(`/emstores/${context.emstore}/emitems/${context.emitem}/empodetails/fetchdefault`,tempData,isloading);
        }
        if(context.emstorepart && context.emitem && true){
            let tempData:any = JSON.parse(JSON.stringify(data));
            return Http.getInstance().get(`/emstoreparts/${context.emstorepart}/emitems/${context.emitem}/empodetails/fetchdefault`,tempData,isloading);
        }
        if(context.emservice && context.emitem && true){
            let tempData:any = JSON.parse(JSON.stringify(data));
            return Http.getInstance().get(`/emservices/${context.emservice}/emitems/${context.emitem}/empodetails/fetchdefault`,tempData,isloading);
        }
        if(context.empo && true){
            let tempData:any = JSON.parse(JSON.stringify(data));
            return Http.getInstance().get(`/empos/${context.empo}/empodetails/fetchdefault`,tempData,isloading);
        }
        if(context.emitem && true){
            let tempData:any = JSON.parse(JSON.stringify(data));
            return Http.getInstance().get(`/emitems/${context.emitem}/empodetails/fetchdefault`,tempData,isloading);
        }
        let tempData:any = JSON.parse(JSON.stringify(data));
        return Http.getInstance().get(`/empodetails/fetchdefault`,tempData,isloading);
    }
}